



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Boot日志集成实战</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Boot日志集成实战</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 05:51:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/5954965-e3bab06feb400353.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<h2>Spring Boot日志框架</h2>
<p>Spring Boot支持Java Util Logging,Log4j2,Lockback作为日志框架，如果你使用starters启动器，Spring Boot将使用Logback作为默认日志框架。无论使用哪种日志框架，Spring Boot都支持配置将日志输出到控制台或者文件中。</p>
<p>spring-boot-starter启动器包含spring-boot-starter-logging启动器并集成了slf4j日志抽象及Logback日志框架。</p>
<h2>属性配置日志</h2>
<p>Spring Boot支持属性配置日志参数，这个不是很灵活，不细讲。</p>
<p>参考配置：</p>
<pre class="prettyprint linenums"><code># LOGGING<br />
logging.config= # Location of the logging configuration file. For instance `classpath:logback.xml` for Logback<br />
logging.exception-conversion-word=%wEx # Conversion word used when logging exceptions.<br />
logging.file= # Log file name. For instance `myapp.log`<br />
logging.level.*= # Log levels severity mapping. For instance `logging.level.org.springframework=DEBUG`<br />
logging.path= # Location of the log file. For instance `/var/log`<br />
logging.pattern.console= # Appender pattern for output to the console. Only supported with the default logback setup.<br />
logging.pattern.file= # Appender pattern for output to the file. Only supported with the default logback setup.<br />
logging.pattern.level= # Appender pattern for log level (default %5p). Only supported with the default logback setup.<br />
logging.register-shutdown-hook=false # Register a shutdown hook for the logging system when it is initialized.<br />
</code></pre>
<p>如：</p>
<pre class="prettyprint linenums"><code>logging.level.root=DEBUG<br />
logging.level.org.springframework.web=DEBUG<br />
logging.level.org.hibernate=ERROR<br />
</code></pre>
<h2>自定义日志文件</h2>
<p>根据不同的日志框架，默认加载的日志配置文件的文件名，放在资源根目录下，其他的目录及文件名不能被加载。</p>
<table>
<thead>
<tr>
<th>Logging System</th>
<th>Customization</th>
</tr>
</thead>
<tbody>
<tr>
<td>Logback</td>
<td>logback-spring.xml, logback-spring.groovy, logback.xml or logback.groovy</td>
</tr>
<tr>
<td>Log4j2</td>
<td>log4j2-spring.xml or log4j2.xml</td>
</tr>
<tr>
<td>JDK (Java Util Logging)</td>
<td>logging.properties</td>
</tr>
</tbody>
</table>
<p>既然默认自带了Logback框架，Logback也是最优秀的日志框架，往资源目录下创建一个logback-spring.xml即可，下面是一个参考配置文件。</p>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />
&lt;configuration debug=&quot;false&quot;&gt;

	&lt;springProperty scope=&quot;context&quot; name=&quot;APP_NAME&quot; source=&quot;spring.application.name&quot;/&gt;<br />
	&lt;springProperty scope=&quot;context&quot; name=&quot;APP_PORT&quot; source=&quot;server.port&quot;/&gt;<br />
	&lt;springProperty scope=&quot;context&quot; name=&quot;DEFAULT_APP_PORT&quot; source=&quot;spring.application.port&quot;/&gt;

	&lt;property name=&quot;OS_NAME&quot; value=&quot;${os.name}&quot;/&gt;<br />
	&lt;if condition='property(&quot;OS_NAME&quot;).contains(&quot;Windows&quot;)'&gt;<br />
		&lt;then&gt;<br />
			&lt;property name=&quot;LOG_PATH&quot; value=&quot;${LOG_PATH:-E:/logs}&quot; /&gt;<br />
		&lt;/then&gt;<br />
		&lt;else&gt;<br />
			&lt;property name=&quot;LOG_PATH&quot; value=&quot;${LOG_PATH:-/log}&quot; /&gt;<br />
		&lt;/else&gt;<br />
	&lt;/if&gt;    	

	&lt;property name=&quot;APP_NAME&quot; value=&quot;${APP_NAME:-system}&quot; /&gt;<br />
	&lt;property name=&quot;APP_PORT&quot; value=&quot;${APP_PORT:-${DEFAULT_APP_PORT}}&quot; /&gt;

	&lt;!-- 控制台输出 --&gt;<br />
	&lt;appender name=&quot;STDOUT&quot; class=&quot;ch.qos.logback.core.ConsoleAppender&quot;&gt;<br />
		&lt;encoder class=&quot;ch.qos.logback.classic.encoder.PatternLayoutEncoder&quot;&gt;<br />
			&lt;!--格式化输出：%d表示日期，%thread表示线程名，%-5level：级别从左显示5个字符宽度，%msg：日志消息，%n是换行符 --&gt;<br />
			&lt;pattern&gt;%d{yyyy-MM-dd HH:mm:ss.SSS} [%thread] %-5level %logger{50} - %msg%n&lt;/pattern&gt;<br />
		&lt;/encoder&gt;<br />
	&lt;/appender&gt;

	&lt;!-- 按照每天生成日志文件 --&gt;<br />
	&lt;appender name=&quot;FILE&quot; class=&quot;ch.qos.logback.core.rolling.RollingFileAppender&quot;&gt;<br />
        &lt;filter class=&quot;ch.qos.logback.classic.filter.LevelFilter&quot;&gt;<br />
            &lt;level&gt;INFO&lt;/level&gt;<br />
            &lt;onMatch&gt;ACCEPT&lt;/onMatch&gt;<br />
            &lt;onMismatch&gt;DENY&lt;/onMismatch&gt;<br />
        &lt;/filter&gt;<br />
		&lt;rollingPolicy class=&quot;ch.qos.logback.core.rolling.TimeBasedRollingPolicy&quot;&gt;<br />
			&lt;!--日志文件输出的文件名 --&gt;<br />
			&lt;FileNamePattern&gt;${LOG_PATH}/${APP_NAME}-${APP_PORT}/info.log.%d{yyyy-MM-dd}.log&lt;/FileNamePattern&gt;

			&lt;!--日志文件保留天数 --&gt;<br />
			&lt;MaxHistory&gt;30&lt;/MaxHistory&gt;<br />
		&lt;/rollingPolicy&gt;

		&lt;encoder class=&quot;ch.qos.logback.classic.encoder.PatternLayoutEncoder&quot;&gt;<br />
			&lt;!--格式化输出：%d表示日期，%thread表示线程名，%-5level：级别从左显示5个字符宽度%msg：日志消息，%n是换行符 --&gt;<br />
			&lt;pattern&gt;%d{yyyy-MM-dd HH:mm:ss.SSS} [%thread] %-5level %logger{50} - %msg%n&lt;/pattern&gt;<br />
		&lt;/encoder&gt;

		&lt;!--日志文件最大的大小 --&gt;<br />
		&lt;triggeringPolicy class=&quot;ch.qos.logback.core.rolling.SizeBasedTriggeringPolicy&quot;&gt;<br />
			&lt;MaxFileSize&gt;10MB&lt;/MaxFileSize&gt;<br />
		&lt;/triggeringPolicy&gt;

	&lt;/appender&gt;

	&lt;!-- 按照每天生成日志文件 error级别 --&gt;<br />
	&lt;appender name=&quot;FILE-ERROR&quot; class=&quot;ch.qos.logback.core.rolling.RollingFileAppender&quot;&gt;<br />
		&lt;filter class=&quot;ch.qos.logback.classic.filter.LevelFilter&quot;&gt;<br />
			&lt;level&gt;ERROR&lt;/level&gt;<br />
			&lt;onMatch&gt;ACCEPT&lt;/onMatch&gt;<br />
			&lt;onMismatch&gt;DENY&lt;/onMismatch&gt;<br />
		&lt;/filter&gt;<br />
		&lt;rollingPolicy class=&quot;ch.qos.logback.core.rolling.TimeBasedRollingPolicy&quot;&gt;<br />
			&lt;!--日志文件输出的文件名 --&gt;<br />
			&lt;FileNamePattern&gt;${LOG_PATH}/${APP_NAME}-${APP_PORT}/error.log.%d{yyyy-MM-dd}.log&lt;/FileNamePattern&gt;

			&lt;!--日志文件保留天数 --&gt;<br />
			&lt;MaxHistory&gt;30&lt;/MaxHistory&gt;<br />
		&lt;/rollingPolicy&gt;

		&lt;encoder class=&quot;ch.qos.logback.classic.encoder.PatternLayoutEncoder&quot;&gt;<br />
			&lt;!--格式化输出：%d表示日期，%thread表示线程名，%-5level：级别从左显示5个字符宽度%msg：日志消息，%n是换行符 --&gt;<br />
			&lt;pattern&gt;%d{yyyy-MM-dd HH:mm:ss.SSS} [%thread] %-5level %logger{50} - %msg%n&lt;/pattern&gt;<br />
		&lt;/encoder&gt;

		&lt;!--日志文件最大的大小 --&gt;<br />
		&lt;triggeringPolicy class=&quot;ch.qos.logback.core.rolling.SizeBasedTriggeringPolicy&quot;&gt;<br />
			&lt;MaxFileSize&gt;10MB&lt;/MaxFileSize&gt;<br />
		&lt;/triggeringPolicy&gt;

	&lt;/appender&gt;

	&lt;!--myibatis log configure --&gt;<br />
	&lt;logger name=&quot;com.apache.ibatis&quot; level=&quot;TRACE&quot; /&gt;<br />
	&lt;logger name=&quot;java.sql.Connection&quot; level=&quot;DEBUG&quot; /&gt;<br />
	&lt;logger name=&quot;java.sql.Statement&quot; level=&quot;DEBUG&quot; /&gt;<br />
	&lt;logger name=&quot;java.sql.PreparedStatement&quot; level=&quot;DEBUG&quot; /&gt;

	&lt;!-- 日志输出级别 --&gt;<br />
	&lt;root level=&quot;INFO&quot;&gt;<br />
		&lt;appender-ref ref=&quot;STDOUT&quot; /&gt;<br />
		&lt;appender-ref ref=&quot;FILE&quot; /&gt;<br />
		&lt;appender-ref ref=&quot;FILE-ERROR&quot; /&gt;<br />
	&lt;/root&gt;

&lt;/configuration&gt;<br />
</code></pre>
<p>强烈推荐使用logback-spring.xml作为文件名，因为logback.xml加载太早。</p>
<p>日志初始化在ApplicationContext创建之前，所以@PropertySources加载的配置是读取不到的，系统环境变量、Spring Environment及application,bootstrap配置文件中的信息可以读取到。</p>
<p>读取系统环境属性：</p>
<pre class="prettyprint linenums"><code>&lt;property name=&quot;LOG_PATH&quot; value=&quot;${LOG_PATH:-E:/logs}&quot; /&gt;<br />
</code></pre>
<p>读取当前应用Environment中的属性：</p>
<pre class="prettyprint linenums"><code>&lt;springProperty scope=&quot;context&quot; name=&quot;fluentHost&quot; source=&quot;myapp.fluentd.host&quot;<br />
        defaultValue=&quot;localhost&quot;/&gt;<br />
</code></pre>
<p>Spring Boot也支持通过springProfile来加载不同profiles下的配置。</p>
<pre class="prettyprint linenums"><code>&lt;springProfile name=&quot;staging&quot;&gt;<br />
    &lt;!-- configuration to be enabled when the &quot;staging&quot; profile is active --&gt;<br />
&lt;/springProfile&gt;

&lt;springProfile name=&quot;dev, staging&quot;&gt;<br />
    &lt;!-- configuration to be enabled when the &quot;dev&quot; or &quot;staging&quot; profiles are active --&gt;<br />
&lt;/springProfile&gt;

&lt;springProfile name=&quot;!production&quot;&gt;<br />
    &lt;!-- configuration to be enabled when the &quot;production&quot; profile is not active --&gt;<br />
&lt;/springProfile&gt;<br />
</code></pre>
<p><strong>推荐：</strong><a href="https://mp.weixin.qq.com/s/N507Cfb_mbkGvHtg_FIaVg" rel="external nofollow noreferrer">Spring Boot &amp; Cloud 最强技术教程</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o4ypeq.html">足球游戏论坛数据分析－－简单粗暴的K均值聚类</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7nyex9.html">《JavaScript高级程序设计》读书笔记--（4）对象的创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/49517g6q.html">FPGA学习笔记之格雷码、边沿检测、门控时钟</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0roeq.html">windows平台（不包括ARM的CE）通用的压缩和解压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z51gv8.html">使用Objective-C的文档生成工具&colon;appledoc</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd66dm8.html">&amp;lt&semi;Error&amp;gt&semi;&colon; CGContextRestoreGState&colon; invalid context 0x0&period; If you want to see the backtrace&comma; please set CG&lowbar;CONTEXT&lowbar;SHOW&lowbar;BACKTRACE environmental variable&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1kxlj9.html">Java中的IO流系统详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dxm39.html">Nodejs初学者福音</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xmx009.html">struts配置，略记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwp7xq.html">［使用］Git－－命令行</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge6l6z8.html">Oracle RAC环境下定位并杀掉最终阻塞的会话-续</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrjl5q.html">poj 1367 robot&lpar;搜索&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2e6goq.html">Gulp入门及简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjg0r9.html">systemctl enable docker&period;service</a>
		</li>
						<li><a href="https://www.batexi.com/a/96055xy9.html">Oracle 查询优化的基本准则详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5vm6q.html">浅谈java中bigInteger用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2y7opq.html">怎样使用PL&sol;SQL在不安装oracle 客户端的情况下使用oracle数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpm3ml9.html">linux shell重定向</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppj4vk9.html">webstorm减少内存占用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emypke9.html">Redis中取得所有Key、过期时间配置与获取、Key过期通知。</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyy02ojq.html">mongodb文件损坏的恢复--无可恢复数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv23dpy9.html">cdnbest自定义错误显示节点名教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjr4g09.html">【Django】网页跳转的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy04pdq.html">cacti的介绍、安装、配置、及维护</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25y023q.html">KBEngine 编译出现 MSB802 无法找到v140的生成工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5k1yrq.html">24&period; Swap Nodes in Pairs 链表每2个点翻转一次</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25y26vq.html">&lbrack;leetcode&rsqb;265&period; Paint House II粉刷房子&lpar;K色可选&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3ke0q.html">Head First Servlets &amp;amp&semi; JSP 学习笔记 第六章 &mdash;&mdash; 会话状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o0dnj8.html">node&period;js中 koa 框架的基本使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wg7vgq.html">stark组件开发之关键搜索</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
